#!/usr/bin/perl

if (scalar(@ARGV) < 2)
{
    die "Usage: install.pl [username of your apache user] [groupname of your apache user]\nOptional, you can add \"wwwblast.tar.gz\" and \"blast.linux.tar.gz\"to install wwwblast from the corresponding files.\n";
}

$wwwuser     = $ARGV[0];
$wwwgrp      = $ARGV[1];
$wwwblasttar = $ARGV[2];
$blasttar    = $ARGV[3];

@files = ("blast.REAL", "nph-viewgif.cgi", "/TmpGifs", "/images", "/data", "/docs", 
	  "blast_form.map", ".nlmstmanrc");

sub create_sblast_dir()
{
    system("mkdir -p $blastdir");
    system("chown -R ".$wwwuser.".".$wwwgrp." $blastdir");	
    system("chmod 700 $blastdir");
}

sub create_db_dir()
{
    system("mkdir -p $dbdir");
    system("chown -R ".$wwwuser.".".$wwwgrp." $dbdir");	
    system("chmod 700 $dbdir");
}

sub check_for_user()
{
    open(IN, $htpasswd);
    while(<IN>)
    {
	($name, $pwd) = split(/:/, $_);
	if ($name eq $sadmin)
	{
	    return 1;
	}
    }
    return 0;
    close(IN);
}

sub create_ncbirc()
{
    $ncbirc = "[BLAST]\nBLASTDB=$dbdir\nDATA=$blastdir\n";
    open (OUT, ">$blastdir/.ncbirc") || die "could not write $blastdir/.ncbirc\nTHIS FILE IS ESSENTIAL !";
    print OUT $ncbirc;
    close (OUT);
}

sub check_for_reg_glob()
{

    $location = "/etc/php.ini";
    if (!-e $location)
    {
	print "$location not found. Please enter the location of your php.ini file:\n";
	$dummy = 0;
        while ($dummy == 0)
        {
	    $location = <STDIN>;
	    chomp($location);
	    if (-e $location)
		{
		    $dummy = 1;
		}
	    else
	    {
		$dummy = 0;
	    }
        }	
    }

    open (IN, $location);
    while (<IN>)
    {
	chomp($_);
	$line = lc($_);
	if (substr($line, 0, 16) eq "register_globals" && index($line, "on") ne -1)
	{
	    print "$line found ! Everything seems to be fine.\n";
	    return;
	}
    }
    print "register_globals seems to be off ! Please change it to \"on\".\n";
    die "Otherwise secureBLAST will not work.\n";
	
}

sub wwwblast_install()
{
    if (-e $wwwblasttar && -e $blasttar)
    {
	print "Going to install wwwblast from $wwwblasttar and $blasttar to $blastdir\n";
	print "This can take some minutes.\n";
	system("tar xzf ".$wwwblasttar);
	system("tar xzf $blasttar formatdb");
	foreach $file (@files)
	{
	    system("cp -r blast/$file $blastdir/");
	}
	system("mv formatdb $formatdb");
	system("cp blast.rc $blastdir");
    }
    else
    {
	print "$wwwblasttar not found ! Skipping this part.\n\n";
	print "Please install the following files and directories from the wwwblast package to $blastdir\n";
	foreach $file (@files)
	{
	    print "$file\n";
	}
	print "\n";
    }
}

print "Extracting config from www/functions.php ....\n\n";
open(IN, "www/functions.php") || die "Could not open www/functions.php !\n";
while (<IN>)
{
    chomp($_);
    ($ident, $cont) = split(/=/, $_);
    $ident =~ s/\s+//g;
    $cont  =~ s/\"//g;
    $cont  =~ s/\;//g;
    $cont  =~ s/\s+//g;

    if ($ident eq "\$cfile")
        {
            $cfile = $cont;
	    print "found sblast config:\t$cfile\n";
        }
        elsif ($ident eq "\$blastdir")
        {
            $blastdir = $cont;
	    print "found blastdir:\t$blastdir\n";
        }
        elsif ($ident eq "\$dbdir")
        {
            $dbdir = $cont;
	    print "found dbdir:\t$dbdir\n";
        }
        elsif ($ident eq "\$blasturl")
        {
            $blasturl = $cont;
	    print "found blasturl:\t$blasturl\n";
        }
        elsif ($ident eq "\$htpasswd")
	{
            $htpasswd = $cont;
	    print "found htpasswd:\t$htpasswd\n";
        }
        elsif ($ident eq "\$sadmin")
	{
            $sadmin = $cont;
	    print "found sadmin:\t$sadmin\n";
        }
        elsif ($ident eq "\$formatdb")
	{
            $formatdb = $cont;
	    print "found formatdb:\t$formatdb\n";
        }
}
close(IN);
print "\n";

print "checking for $dbdir ...\n";

if (!-e "$dbdir")
    {
	print "$dbdir was not found ! Creating ...\n";
	create_db_dir();
    }
else
    {
	print "$dbdir was found ! Changing owner to $wwwuser\n";
	system("chown -R ".$wwwuser.".".$wwwgrp." $dbdir");
	system("chmod 700 $dbdir");
    }

if (!-e "$blastdir")
    {
	print "$blastdir was not found ! Creating ...\n";
	create_sblast_dir();
    }
else
    {
	print "$blastdir was found ! Changing owner to $wwwuser\n";
	system("chown -R ".$wwwuser.".".$wwwgrp." $blastdir");	
	system("chmod 700 $blastdir");
    }



if (!-e $htpasswd)
{
    print "$htpasswd not found ! Creating new one with secureBLAST admin \"$sadmin\"\nPlease choose a password:\n";
    system("htpasswd -c $htpasswd $sadmin");
    system("chown ".$wwwuser.".".$wwwgrp." $htpasswd");
}
else
{


    if (check_for_user() eq 0)
    {
	print "$htpasswd found ! Creating new entry for secureBLAST admin \"$sadmin\"\nPlease choose a password:\n";
	system("htpasswd $htpasswd $sadmin");
    }
    else
    {
	print "$htpasswd found ! User secureBLAST admin \"$sadmin\" already exists.\nLeaving file untouched.\n";
    }
}

check_for_reg_glob();
if ($wwwblasttar ne "")
{
    wwwblast_install();
}
create_ncbirc();

print "writing sblast.conf to $cfile\n";
system("cp sblast.conf $cfile");
system("chown ".$wwwuser.".".$wwwgrp." $cfile");
system("chmod 600 $cfile");
system("cp www/*.php $blastdir");
system("mkdir $blastdir/images");
system("cp www/images/* $blastdir/images");
system("chown -R ".$wwwuser.".".$wwwgrp." $blastdir");
system("chmod -R 600 $blastdir/*");
system("chmod 700 $blastdir/blast.REAL");
system("chmod 700 $blastdir/blast.rc");
system("chmod 700 $blastdir/formatdb");
system("chmod 700 $blastdir/nph-viewgif.cgi");
system("chmod 700 $blastdir/data");
system("chmod 700 $blastdir/data/CVS");
system("chmod 700 $blastdir/docs");
system("chmod 700 $blastdir/images");
system("chmod 700 $blastdir/TmpGifs");

if (!-e "$blastdir/blast.rc")
{
    print "$blastdir/blast.rc was not found. Please install wwwblast before you start with secureBLAST !\n";
}

if (!-e "$formatdb")
{
    print "$formatdb was not found. Please install wwwblast before you start with secureBLAST !\n";
}

print "Done !\n";
print "You can check your installation at $blasturl !\n";
