<?php
/*
Copyright (C) 2003 Arnim Wiezer <awiezer@g2l.bio.uni-goettingen.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

include "functions.php";

session_start();

if ( !auth($username, $password) ) 
{ 
   loginform(); 
} 
else
{
  if (!session_is_registered('db'))
    {
      small_head();
  
      echo "<h2>Direct sequence access: </h2>";
      echo "<form action=\"$blasturl/seq.php?PHPSESSID=".session_id()."\" METHOD=POST>\n";
      echo "Please choose a database:<br>\n";
      echo "<select name = \"db\">\n";
      
      // show database selector
      sort($authdata['dbread']);
      foreach ($authdata['dbread'] as $db )
	echo "<option VALUE = \"", $db['name'], "\">", $db['desc'], "\n";
      echo "</select><br>\n";
      session_register('db');
      echo "<INPUT TYPE=\"submit\" VALUE=\"submit\"><hr>\n";
      echo "</form>\n";
    }
  else
    {
      // call without input
      if (!empty($db[name]) && empty($selcontig) && empty($start) && empty($stop) && authorized($authdata[dbread], $db[name]))
	{
	  foreach ($authdata['dbread'] as $dbr)
	    if ($dbr[name] == $db[name])
	      $desc = $dbr[desc];

	  // get contig names
	  $contigs = get_contig_names($db[name]);
	  echo "You selected db: <font color=red>$desc</font>\n";
	  echo "<form action=\"$blasturl/seq2.php?PHPSESSID=".session_id()."\" METHOD=POST>\n";
	  
	  echo "Please select a contig !<br>\n";
	  echo "<select name = \"selcontig\">\n";
	  sort($contigs);
	  foreach ($contigs as $contig )
	    echo "<option VALUE = \"", $contig, "\">", $contig, "\n";
	  echo "</select><br>\n";
	  
	  echo "start: <input type=\"text\" name=\"start\" size=12 maxlen=12><br>\n";
	  echo "stop: <input type=\"text\" name=\"stop\" size=12 maxlen=12><br>\n";
	  echo "<INPUT TYPE=\"submit\" VALUE=\"submit\"><hr>\n";
	  echo "</form>\n";
	}
      else
	{
	  if (!is_numeric($start) && !is_numeric($stop))
	    {
	      echo "Start and Stop must be numerical !";
	      exit;
	    }
	  $seq = get_seq_from_db($db[name], $selcontig, $start, $stop);
	  echo "<pre>>$selcontig\n$seq</pre>\n";
	  session_unregister('db');
	}
    }
}

php?>