<?php

/*
Copyright (C) 2003 Arnim Wiezer <awiezer@g2l.bio.uni-goettingen.de>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

include "functions.php";

session_start();
if  (!session_is_registered('authdata'))
     loginform();
     else
{
  global $tmpdir;
  small_head();

  if ($sent or $ok == "yes")
    {
      if ($ok == "yes")
	{
	  if (!file_exists("$dbdir/$filename"))
	    noupdate($filename);
	  else
	    {
	      
	      // escapeshellcmd() escapes any characters in a string that might be used to trick a 
	      // shell command into executing arbitrary commands. 
	      
	      $dbdir_sec = escapeshellcmd($dbdir);
	      $filename_sec = escapeshellcmd($filename);
	      
	      // lock db
	      echo "Locking database and moving input file to database directory....<p>\n";
	      if (lockdb($filename) != true)
		{
		  if (islocked($filename))
		    {
		      echo "Sorry... the database is already locked.";
		      $fp = "$tmpdir/$filename.lock";
		      $filemodtime = date("F j Y h:i:s A", filemtime($fp)); 
		      echo "The lockfile for $filename was last modified $filemodtime<br>";
		      echo "If you think, this file is a leftover of a very old update, please contact ";
		      echo "$admin to delete the lockfile<p>\n";
		      exit;
		    }
		  else
		    errormsg("The database could not be locked");
		}
	      else
		echo "done.<br>\n"; // datebase locked
	      
	      // move uploaded file
	      if (system("mv $tmpdir/$filename $dbdir/$filename") === false)
		{
		  unlockdb($filename_sec);
		  errormsg("Your file could not be moved");
		}
	      else
		{
		  echo "done.<br>\n"; // file moved
		  echo "<hr>Calling formatdb to make your fasta file BLAST compatible...\n";
		  $output = exec("$formatdb  -p $protein -o T -i $dbdir_sec/$filename_sec");
		  if ($output == "") 
		    $output = "none";
		  echo "<p>Output of formatdb: <font color=blue>$output</font><hr>\n";
		  echo "done.<br>\n";
		  
		  echo "un-locking database...\n";
		  if (unlockdb($filename_sec) != true)
		    errormsg("The database could not be un-locked");
		  else
		    echo "done.<br>\n"; // datebase unlocked
		  
		  echo "<h2>That should be all. Thank you !</h2>\n";
		  echo "Back to <a href=\"$blasturl\"><i>secureBLAST</i></a>\n";
		}
	    }
	}
      else // ok == "no" & sent == "yes"
	{
	  if (!authorized($authdata['dbwrite'], $filename))
	    noupdate($filename);
	  
	  $headlength = 50;

	  echo "<h1>Please check if the format of your input is correct !</h1>";
	  echo "An example for a correcly formated fasta file can be found ";
	  echo "<a href=\"$blasturl/docs/fasta.html\">here</a>.<p>\n";
	  echo "The sequence you want in your BLAST database looks like this (first $headlength lines):\n";
	  echo "<hr>Do you want your database formated in this way ?\n";
	  echo "Your filename will be: <font color=red>$filename</font>\n";      
	  // lets check the format 
	      
	  echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"$blasturl/update.php\">\n";
	  
	  echo "<input type=hidden name=filename value=$filename>\n";
	  echo "<input type=hidden name=protein value=$protein>\n";
	  echo "<input type=submit name=ok value=yes>\n";
	  echo "<input type=submit name=ok value=no>\n";
	  echo "</form><hr>\n";
	  
	  // display sequence *************************************** 
	  // -> file upload 
 
	  if (!empty($userfile))  
	    {
	      echo "<pre>";
	      filehead($headlength, $userfile);
	      echo "</pre>";
	      
	      // save sequence to file 
	      if (is_uploaded_file($_FILES['userfile']['tmp_name'])) 
		{
		  move_uploaded_file($_FILES['userfile']['tmp_name'], "$tmpdir/$filename");
		} 
	      else 
		echo "Possible file upload attack. Filename: " . $_FILES['userfile']['name'];
	    }
	  else
	    {
	      if ($filename == "" && $seq != "")
		{
		  echo "<h1>You didn't enter a filename for your sequence please go ";
		  echo "<a href=\"$blasturl/update.php\">back</a> !</h1>\n";
		  exit;
		}
	      else // create file out of input
		{
		  $filename = $tmpdir."/".$filename;
		  // In our example we're opening $filename in append mode.
		  // The file pointer is at the bottom of the file hence 
		  // that's where $somecontent will go when we fwrite() it.
		  if (!$fp = fopen($filename, 'w+')) 
		    {
		      print "Cannot open file ($filename)";
		      exit;
		    }
		  
		  // Write $somecontent to our opened file.
		  if (!fwrite($fp, $seq)) 
		    {
		      print "Cannot write to file ($filename)";
		      exit;
		    }
		  fclose($fp);
		} 
	      echo "<pre>$seq</pre>";
	      echo "<hr>\n";
	    }

	}
    }
  else // sent == "0"
    {
      /* we allready displayed the uploaded file or sequence from the textwindow, but the user doesn't like the output
         so we start again and delete the old files */
      
      if ($ok == "no") 
	unlink("$tmpdir/$filename");
      
      // this is the start page
      echo "<h3>Welcome <i>$authdata[login]</i> ! Happy Update-ing...</h3>\n";
      echo "<h2>Please paste your <a href=\"docs/fasta.html\">fasta</a> sequence here and choose the ";
      echo "corresponding database.</h2>\n";
      echo "Or click <a href=\"$blasturl/index.php?PHPSESSID=".session_id()."\">here</a> to go back to BLAST\n";
      
      // the form begins here 
      echo "<form enctype=\"multipart/form-data\" method=\"POST\" action=\"$blasturl/update.php?PHPSESSID=".session_id()."\">\n";
      echo "<textarea name=\"seq\" rows=10 cols=80></textarea><p>\n";
      echo "Please choose a database to update:\n";
      echo "<select name = \"filename\">\n";
      
      foreach ($authdata['dbwrite'] as $db )
	echo "<option VALUE = \"", $db['name'], "\">", $db['desc'], "\n";
      
      echo "</select>\n";
      echo "<p><hr>\n";
      
      echo "<h2>Or use the browse button to upload a fasta file...</h2>\n";
      echo "<input name=\"userfile\" type=\"file\" accept=\"text/*\">\n";
      echo "<hr>\n";
      echo "Please choose your <font color=red>sequence type</font> !<p>\n";
      echo "DNA: <input type=radio name=protein value=F checked>\n";
      echo "Protein: <input type=radio name=protein value=T><p>\n";
      echo "<input type=submit value=upload>\n";
      echo "<input type=reset>\n";
      echo "<input type=hidden name=sent value=1>\n";
      echo "</form>\n";
      
      echo "<hr><small>Comments and suggestions to<address>";
      echo "<a href=\"mailto:$admin\">$admin</a></address></small>\n ";
    }
  
  echo "</body></html>\n";
}
php?>